# coding: utf-8

"""
    Synapse DB

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.5.27
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations

import json
import pprint
import re  # noqa: F401
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, StrictStr
from syndb_api_client.models.animal_model_read import AnimalModelRead
from syndb_api_client.models.brain_region_read import BrainRegionRead
from syndb_api_client.models.mutation_model_read import MutationModelRead
from typing_extensions import Self


class UniversalMetadataResponse(BaseModel):
    """
    UniversalMetadataResponse
    """  # noqa: E501

    publication_dois: Optional[List[StrictStr]] = None
    animal: Optional[List[AnimalModelRead]] = None
    mutation: Optional[List[MutationModelRead]] = None
    brain_region: Optional[List[BrainRegionRead]] = None
    microscopy_names: Optional[List[StrictStr]] = None
    all_datasets: Dict[str, StrictStr]
    __properties: ClassVar[List[str]] = [
        "publication_dois",
        "animal",
        "mutation",
        "brain_region",
        "microscopy_names",
        "all_datasets",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UniversalMetadataResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in animal (list)
        _items = []
        if self.animal:
            for _item in self.animal:
                if _item:
                    _items.append(_item.to_dict())
            _dict["animal"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in mutation (list)
        _items = []
        if self.mutation:
            for _item in self.mutation:
                if _item:
                    _items.append(_item.to_dict())
            _dict["mutation"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in brain_region (list)
        _items = []
        if self.brain_region:
            for _item in self.brain_region:
                if _item:
                    _items.append(_item.to_dict())
            _dict["brain_region"] = _items
        # set to None if publication_dois (nullable) is None
        # and model_fields_set contains the field
        if self.publication_dois is None and "publication_dois" in self.model_fields_set:
            _dict["publication_dois"] = None

        # set to None if animal (nullable) is None
        # and model_fields_set contains the field
        if self.animal is None and "animal" in self.model_fields_set:
            _dict["animal"] = None

        # set to None if mutation (nullable) is None
        # and model_fields_set contains the field
        if self.mutation is None and "mutation" in self.model_fields_set:
            _dict["mutation"] = None

        # set to None if brain_region (nullable) is None
        # and model_fields_set contains the field
        if self.brain_region is None and "brain_region" in self.model_fields_set:
            _dict["brain_region"] = None

        # set to None if microscopy_names (nullable) is None
        # and model_fields_set contains the field
        if self.microscopy_names is None and "microscopy_names" in self.model_fields_set:
            _dict["microscopy_names"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UniversalMetadataResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "publication_dois": obj.get("publication_dois"),
                "animal": (
                    [AnimalModelRead.from_dict(_item) for _item in obj["animal"]]
                    if obj.get("animal") is not None
                    else None
                ),
                "mutation": (
                    [MutationModelRead.from_dict(_item) for _item in obj["mutation"]]
                    if obj.get("mutation") is not None
                    else None
                ),
                "brain_region": (
                    [BrainRegionRead.from_dict(_item) for _item in obj["brain_region"]]
                    if obj.get("brain_region") is not None
                    else None
                ),
                "microscopy_names": obj.get("microscopy_names"),
                "all_datasets": obj.get("all_datasets"),
            }
        )
        return _obj
